/*
 * Initializes the page
 */
AJS.toInit( function() {
  
 loadConfiguration();
 
});

/*
 * Loads the configuration from the backend
 */
function loadConfiguration() {
  AJS.$.ajax({
      url: AJS.contextPath() + "/rest/samlsso-toolbox/1.0/configuration",
      dataType: "json",
      type: "get",
      success: function(config) {
          reinitializeTable(config)
      },
      error: function() {
          AJS.flag({
              type: 'error',
              title: 'Could not load configurations.',
              body: 'This should not happen. Please check the server logs.'
          });
      }
  });
}

// Url Mapping entries
function reinitializeTable(config) {
    var configTableBody = AJS.$('#configuration-table-body');
    configTableBody.html("");
    config.forEach(function(entry) {
        var newTableEntry = AJS.$("<tr/>");
        configTableBody.append(newTableEntry);
        newTableEntry.append(AJS.$("<td>" + entry.description + "</td>"));
        newTableEntry.append(AJS.$("<td>" + entry.version + "</td>"));

        if (entry.stored) {
            var actionsCell = AJS.$("<td/>");
            if(entry.version != 0) {
                createActionLink('aui-iconfont-down', 'Download', actionsCell, AJS.contextPath() + "/rest/samlsso-toolbox/1.0/configuration/" + entry.key);
            }
            createActionLink('aui-iconfont-remove', 'Delete', actionsCell, function () {
                console.log("deleting entry with key ", entry.key);
                AJS.$.ajax({
                    url: AJS.contextPath() + "/rest/samlsso-toolbox/1.0/configuration/" + entry.key,
                    dataType: "json",
                    type: "delete",
                    success: function(config) {
                        AJS.flag({
                            type: 'success',
                            title: 'Configuration deleted',
                            body: 'Please make sure to disable and re-enable the SAML Single Sign On add-on.'
                        });
                        loadConfiguration();
                    },
                    error: function() {
                        AJS.flag({
                            type: 'error',
                            title: 'Could not delete configuration',
                            body: 'This should not happen. Please check the server logs.'
                        });
                    }
                });
            });
            newTableEntry.append(actionsCell);
        }
        else {
            newTableEntry.append(AJS.$("<td>Not stored</td>"));
        }

    });
    if (config.length === 0) {
        configTableBody.append(AJS.$("<tr><td colspan='2'>No configurations found!</td></tr>"));
    }
}

function createActionLink (iconId, text, parent, callback) {
    var $newAction;
    if (typeof callback === "string") {
        $newAction = AJS.$("<a href='" + callback + "' target='_blank'/>");
    } else {
        $newAction = AJS.$("<a />");
        $newAction.click(callback);
    }
    $newAction.append(AJS.$("<span class='vanityurl-nowrap-span'><span class='aui-icon aui-icon-small " + iconId + "'>" + text + "</span> " + text + "</span>"));
    parent.append($newAction);
}